/*
 * 创客循环返风控月汇总
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserSwapSummaryController : BaseController
    {
        public UserSwapSummaryController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 创客循环返风控月汇总列表

        /// <summary>
        /// 根据条件查询创客循环返风控月汇总列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserSwapSummary data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            return View();
        }

        #endregion

        #region 根据条件查询创客循环返风控月汇总列表

        /// <summary>
        /// 创客循环返风控月汇总列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserSwapSummary data, string MakerCode, string RealName, string TopMakerCode, string TopRealName, string RiskStatusSelect, string TradeMonthSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("UpdateDate", "3"); //时间
            Fields.Add("BrandId", "0"); //品牌

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //顶级创客编号
            if (!string.IsNullOrEmpty(TopMakerCode))
            {
                condition += " and TopUserId in (select UserId from UserForMakerCode where MakerCode='" + TopMakerCode + "')";
            }
            //顶级创客名称
            if (!string.IsNullOrEmpty(TopRealName))
            {
                condition += " and TopUserId in (select UserId from UserForRealName where RealName='" + TopRealName + "')";
            }
            //循环风控降档状态
            if(!string.IsNullOrEmpty(RiskStatusSelect))
            {
                condition += " and RiskStatus=" + RiskStatusSelect;
            }
            //交易月份
            if(!string.IsNullOrEmpty(TradeMonthSelect))
            {
                condition += " and TradeMonth=" + TradeMonthSelect.Replace("-", "");
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserSwapSummary", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandName"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                dic["SwapExtProductTypes"] = RelationClass.GetKqProductBrandList(dic["SwapExtProductTypes"].ToString());
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                int TopUserId = int.Parse(dic["TopUserId"].ToString());
                Users tuser = db.Users.FirstOrDefault(m => m.Id == TopUserId) ?? new Users();
                dic["TopMakerCode"] = tuser.MakerCode;
                dic["TopRealName"] = tuser.RealName;
                int RiskStatus = int.Parse(dic["RiskStatus"].ToString());
                if(RiskStatus == 0) dic["RiskStatus"] = "降档";
                if(RiskStatus == 1) dic["RiskStatus"] = "不降档";
            }
            Dictionary<string, object> other = new Dictionary<string, object>();
            other.Add("DirectActMerCount", 0);
            other.Add("RiskCount", 0);
            obj.Add("other", other);
            return Json(obj);
        }

        #endregion

        #region 增加创客循环返风控月汇总

        /// <summary>
        /// 增加或修改创客循环返风控月汇总信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加创客循环返风控月汇总

        /// <summary>
        /// 增加或修改创客循环返风控月汇总信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserSwapSummary data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserSwapSummary", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserSwapSummary", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改创客循环返风控月汇总

        /// <summary>
        /// 增加或修改创客循环返风控月汇总信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            UserSwapSummary editData = db.UserSwapSummary.FirstOrDefault(m => m.Id == Id) ?? new UserSwapSummary();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改创客循环返风控月汇总

        /// <summary>
        /// 增加或修改创客循环返风控月汇总信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserSwapSummary data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSwapSummary", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserSwapSummary", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除创客循环返风控月汇总信息

        /// <summary>
        /// 删除创客循环返风控月汇总信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserSwapSummary", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSwapSummary", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserSwapSummary", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSwapSummary", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserSwapSummary", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSwapSummary", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserSwapSummary", Sort, Id);

            AddSysLog(Id.ToString(), "UserSwapSummary", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.UserSwapSummary.Add(new UserSwapSummary()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserSwapSummary", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserSwapSummary data, string MakerCode, string RealName, string TopMakerCode, string TopRealName, string RiskStatusSelect, string TradeMonthSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("UpdateDate", "3"); //时间
            Fields.Add("BrandId", "0"); //品牌

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //顶级创客编号
            if (!string.IsNullOrEmpty(TopMakerCode))
            {
                condition += " and TopUserId in (select UserId from UserForMakerCode where MakerCode='" + TopMakerCode + "')";
            }
            //顶级创客名称
            if (!string.IsNullOrEmpty(TopRealName))
            {
                condition += " and TopUserId in (select UserId from UserForRealName where RealName='" + TopRealName + "')";
            }
            //循环风控降档状态
            if(!string.IsNullOrEmpty(RiskStatusSelect))
            {
                condition += " and RiskStatus=" + RiskStatusSelect;
            }
            //交易月份
            if(!string.IsNullOrEmpty(TradeMonthSelect))
            {
                condition += " and TradeMonth=" + TradeMonthSelect.Replace("-", "");
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserSwapSummary", Fields, "Id desc", "0", 1, 20000, condition, "UserId,TopUserId,TradeMonth,BrandId,DirectActMerCount,DirAvgTradeAmt,RiskStatus,SwapExtProductTypes", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                dic["SwapExtProductTypes"] = RelationClass.GetKqProductBrandList(dic["SwapExtProductTypes"].ToString());
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                int TopUserId = int.Parse(dic["TopUserId"].ToString());
                Users tuser = db.Users.FirstOrDefault(m => m.Id == TopUserId) ?? new Users();
                dic["TopMakerCode"] = tuser.MakerCode;
                dic["TopRealName"] = tuser.RealName;
                int RiskStatus = int.Parse(dic["RiskStatus"].ToString());
                if(RiskStatus == 0) dic["RiskStatus"] = "降档";
                if(RiskStatus == 1) dic["RiskStatus"] = "不降档";
                dic.Remove("UserId");
                dic.Remove("TopUserId");
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("TradeMonth", "交易月份");
            ReturnFields.Add("MakerCode", "创客编号");
            ReturnFields.Add("RealName", "创客姓名");
            ReturnFields.Add("TopMakerCode", "顶级创客编号");
            ReturnFields.Add("TopRealName", "顶级创客名称");
            ReturnFields.Add("BrandId", "产品名称");
            ReturnFields.Add("DirectActMerCount", "上月新增数");
            ReturnFields.Add("DirAvgTradeAmt", "户均(元)");
            ReturnFields.Add("RiskStatus", "是否风控降档");
            ReturnFields.Add("SwapExtProductTypes", "可申请循环产品");
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserSwapSummary", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
